' TOSPLOT.BAS
' Converts tabulated WOD to SPLOT format
' Written by C.Wallis G3CWV
' BASIC interpreter ... Microsoft QBASIC
' Created 29-Mar-93
' v 1.0  01-Nov-95  Issued
' v 1.1  19-Dec-95  Guide added for chan numbers
' v 1.2  24-Mar-99  Year 99 date problem corrected

DIM chan(10)         'Array containing channel numbers
DIM values(10)       'Array of channel values

KEY(1) ON
ON KEY(1) GOSUB key.trap

'-------------------------------------
DEF FNdayNo (Y, M, D)
'Converts date to unix day number, ie days from 1-1-1970

IF M <= 2 THEN Y = Y - 1: M = M + 12
FNdayNo = INT(Y * 365.25) + INT((M + 1) * 30.6) + D - 719606
END DEF
'---------------------------------------
        CLS

        PRINT "   PROGRAM FOR CONVERTING OSCAR-11 TABULATED WOD TO SPLOT FORMAT"
        PRINT "            TOSPLOT.BAS   V 1.1  19-Dec-1996"
        PRINT "               Written by C.Wallis  G3CWV"
        PRINT
        PRINT

        INPUT "Enter INPUT file name  ", in.file$
        PRINT
        OPEN in.file$ FOR INPUT ACCESS READ AS #1
        INPUT "Enter OUTPUT file name  ", out.file$
        PRINT
        OPEN out.file$ FOR OUTPUT ACCESS WRITE AS #2
        DO
        INPUT "Enter total number of channels in survey   ", channels
        PRINT
        INPUT "Enter channel numbers in order of WOD <n1 n2 n3 n4 ... >   ", reply$
        GOSUB get.values
        IF channels <> number.of.values THEN
                PRINT
                PRINT "Wrong number of channels ... try again"
                PRINT
        END IF
        LOOP UNTIL channels = number.of.values
        PRINT
        FOR i = 1 TO channels        'Set up chan array
           chan(i) = values(i)
        NEXT
        GOSUB set.unix.time

        PRINT
        PRINT "Please wait ..... processing data"

        PRINT #2, "$I 2"
        PRINT #2, "$F uo2tlm.cfg"
        PRINT #2, "$C"; channels;
        FOR i = 1 TO channels
           PRINT #2, ","; chan(i);
        NEXT
        PRINT #2,
'                        /* Process file until EOF   */
   DO
        FOR i = 0 TO channels
               IF NOT EOF(1) THEN INPUT #1, values(i)
         NEXT
             unix.time& = unix.start.time& + values(0) * 4.84
             PRINT #2, "$T "; unix.time&
         FOR i = 1 TO channels
              PRINT #2, USING "##_, ####"; chan(i); values(i)
         NEXT
   LOOP UNTIL EOF(1)
        PRINT : PRINT
        PRINT "End of Data ... Processing complete"
        CLOSE
        SYSTEM
'---------------------------------------------------------------------


get.values:

'Extracts integer values from string read from keyboard
'Input reply$
'Outputs values(10), number.of.values

GOSUB purge.string
ptr = 0
i = 1
DO
    GOSUB numeric
    values(i) = VAL(MID$(data.string$, ptr))
    GOSUB non.numeric
    i = i + 1
LOOP UNTIL ((ptr > LEN(data.string$)) OR (i > 10))
number.of.values = i - 1
RETURN
'---------------------------------
numeric:
     ' Input data.string$, ptr
     ' Output ptr
     '  Scans data.string$ for a numeric character
     DO
     ptr = ptr + 1
     LOOP UNTIL ((MID$(data.string$, ptr, 1) <> ",") OR (ptr > LEN(data.string$)))
     RETURN
 ' -------------------------------
non.numeric:
' Input data.string$, ptr
' Output ptr
' Scans data.string$ for comma character
     DO
     ptr = ptr + 1
     LOOP UNTIL ((MID$(data.string$, ptr, 1) = ",") OR (ptr > LEN(data.string$)))
     RETURN
'--------
purge.string:
'converts non numeric characters to commas
'Input reply$
'Output data.string$

data.string$ = ""

FOR i = 1 TO LEN(reply$)
char$ = MID$(reply$, i, 1)
    SELECT CASE char$
        CASE "0" TO "9"
                data.string$ = data.string$ + char$
        CASE ELSE
                data.string$ = data.string$ + ","
    END SELECT
NEXT
RETURN
'---------------------------------------------------
key.trap: SYSTEM
RETURN
 '--------------------------------------------------

set.unix.time:
'  Prompts operator to enter date and time.
'  Year may be long or short form.  Month must be numeric.
'  Seperators may be spaces,or any punctuation characters.
'  Output unix.start.time


DO
PRINT
INPUT "Enter date of WOD survey  <yy mm dd>   ", reply$
GOSUB get.values
LOOP UNTIL number.of.values = 3
yy = values(1)
mm = values(2)
dd = values(3)

IF yy < 60 THEN yy = yy + 2000 ELSE yy = yy + 1900
dn = FNdayNo(yy, mm, dd)

DO
  PRINT
  INPUT "Enter starting time of WOD survey UTC   <hh mm ss>   ", reply$
  GOSUB get.values
LOOP UNTIL number.of.values = 3
hh = values(1)
mn = values(2)
ss = values(3)
unix.start.time& = dn * 24 * 60 * 60 + hh * 60 * 60 + mn * 60 + ss
RETURN
'-------------------------------------------------------
